%% HDR-VDP-2: A calibrated visual metric for visibility and quality predictions in all luminance conditions
% matlab version
%
% -----------------------------------------------------------------
% Documentation
%
% HDRVDP - run HDR-VDP-2 on a pair of images
% HDRVDP_VISUALIZE - produce visualization of the probability maps
% HDRVDP_PIX_PER_DEG - compute an angular resolution required for HDR-VDP-2
%
% -----------------------------------------------------------------
% Example: 
function [res] = Contents_fun(T,R) 



 addpath('matlabPyrTools/MEX');
 addpath('matlabPyrTools');

%  % Load reference and test images
% T = double(imread( 'DistortedImage.jpg' ))/2^8;

% R = double(imread( 'OriginalImage.jpg' ))/2^8;
%
%  % Compute pixels per degree for the viewing conditions
%  ppd = hdrvdp_pix_per_deg( 21, [size(T,2) size(T,1)], 1 );
%
%  % Run hdrvdp
 % res = hdrvdp( T, R, 'sRGB-display', 30 );
 % tic
  res = hdrvdp( T, R, 'luma-display', 30 );
 % disp('well');
 % toc;
%




%  reference = logspace( log10(0.1), log10(1000), 512 )' * ones( 1, 512 );
%  test = reference .* (1 + (rand( 512, 512 )-0.5)*0.02);
%  subplot(1,3,1);
%  imshow(reference);
%  subplot(1,3,2);
%  imshow(test);
%  cha = reference - test;
%  subplot(1,3,3);
%  imshow(cha);
%  res = hdrvdp( test, reference, 'luminance', 30 );
% % res = hdrvdp( T, R, 'luminance', 30 );
% figure;
% imshow( hdrvdp_visualize( res.P_map, test ) )
% imshow( hdrvdp_visualize( res.P_map, R ) )
%
% Copyright (c) 2004-2011, Rafal Mantiuk <mantiuk@gmail.com>
%
% Permission to use, copy, modify, and/or distribute this software for any
% purpose with or without fee is hereby granted, provided that the above
% copyright notice and this permission notice appear in all copies.
%
% THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
% WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
% MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
% ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
% WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
% ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
% OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
