
function [Loc_dis] = dist_art_weights(Ori_image,RO_image,Ori_sal,RO_sal,patch_size)
 % compute the distance between the original image (Ori_image) and the
 % retargeted result(RO_image)
 Ori_image = double(Ori_image)./255.0;
 RO_image = double(RO_image)./255.0;  
 Ori_image = rgb2lab(Ori_image(:,:,1),Ori_image(:,:,2),Ori_image(:,:,3));
 RO_image = rgb2lab(RO_image(:,:,1),RO_image(:,:,2),RO_image(:,:,3));
%  figure;
%  imshow(Ori_image);
%  figure;
%  imshow(RO_image);
% clear all
% close all
% Ori_image = imread('ArtRoom.bmp');
% RO_image = imread('ArtRoom_0.75_cr.bmp');
% Ori_sal = imread('ArtRoom_RC.png');
% RO_sal = imread('ArtRoom_0.75_cr_RC.png');
Ori_sal_nor = double(Ori_sal)/255.00;
RO_sal_nor = double(RO_sal)/255.00;
% figure;
% imshow(Ori_sal);
% figure;
% imshow(RO_sal)
% patch_size = 80;

% Ori_image = double(Ori_image(:,:,:))./255.0;
% RO_image = double(RO_image(:,:,:))./255.0;
%patch_size = 80;
% figure;
% imshow(Ori_image);
% figure;
% imshow(RO_image);
Ori_image(:,:,1) = Ori_image(:,:,1)./100.0;
Ori_image(:,:,2) = Ori_image(:,:,2)./128.0;
Ori_image(:,:,3) = Ori_image(:,:,3)./128.0;
RO_image(:,:,1) = RO_image(:,:,1)./100.0;
RO_image(:,:,2) = RO_image(:,:,2)./128.0;
RO_image(:,:,3) = RO_image(:,:,3)./128.0;

[ori_rows,ori_cols,dims] = size(Ori_image);
[ro_rows,ro_cols,dims] = size(RO_image);
ori_row_num = fix(ori_rows/patch_size);
ori_col_num = fix(ori_cols/patch_size);
dist_ori_ro = double(zeros(ori_row_num*ori_col_num,1));
ro_row_num = fix(ro_rows/patch_size);
ro_col_num = fix(ro_cols/patch_size);
dist_ro_ori = double(zeros(ro_row_num*ro_col_num,1));
ori_patch_weight = zeros(patch_size.^2,ori_row_num*ori_col_num);
ro_patch_weight = zeros(patch_size.^2,ro_row_num*ro_col_num);

%k = ori_row_num * ori_col_num;
k = 0;
% ori_patch() record all the patches from the original image in ori_patch, the i'th patch is stored i ori_patch(:,i)
ori_patch = zeros(patch_size*patch_size*3,ori_row_num * ori_col_num);
tic
for i = 1 : ori_row_num
    for j = 1 : ori_col_num
        row_b = (i-1) * patch_size + 1;
        row_t = i * patch_size;
        col_b = (j-1) * patch_size + 1;
        col_t = j * patch_size;
        temp = Ori_image(row_b:row_t,col_b:col_t,:);
        temp_ori_sal = Ori_sal_nor(row_b:row_t,col_b:col_t,:); % record the saliency value of each pixel of the k'th patch about the original image Ori_image
%         imshow(temp);
%         k = k + 1;
%         x = temp(:);
%         y = reshape(x,patch_size,patch_size,3);
%         figure;
%         imshow(y);
        k = k + 1;
        ori_patch(:,k) = temp(:);
        ori_patch_weight(:,k) = temp_ori_sal(:);
    end        
end
toc;
% record all the patches from the retargeted results in ro_patch, the i'th
% patch is recorded in ro_patch(:,i)
% ro_patch = zeros(patch_size * patch_size * 3,ro_row_num * ro_col_num);
dist_all_ro_ori = zeros(ro_row_num * ro_col_num,ori_row_num * ori_col_num);

k = 0;
tic
for i = 1 : ro_row_num
    for j = 1 : ro_col_num
        row_b = (i-1) * patch_size + 1;
        row_t = i * patch_size;
        col_b = (j-1) * patch_size + 1;
        col_t = j * patch_size;
        temp = RO_image(row_b:row_t,col_b:col_t,:);
        temp_ro_sal = RO_sal_nor(row_b:row_t,col_b:col_t,:);
        k = k + 1;
        ro_patch_weight(:,k) = temp_ro_sal(:); % record the saliency value of each pixel of the k'th patch about the retargeted result RO_image
%         figure;
%         imshow(temp);        
       % ro_patch(:,k) = temp(:);
        temp_img = repmat(temp(:),1,ori_row_num * ori_col_num);% copy the value of the k'th patch from the retargeted result to form a data with the same rows and cols
        temp_dis = sum((temp_img - ori_patch).^2)/(patch_size.^2);
        dist_all_ro_ori(k,:) = temp_dis;   % record the distance from the k'th patch of retargeted image to all the patches of orginal images()
%         t = reshape(ro_patch(:,k),patch_size,patch_size,3);
%         figure;
%         imshow(t);
        
    end
end
toc;
ori_pwei = sum(ori_patch_weight)/(patch_size.^2);
ro_pwei = sum(ro_patch_weight)/(patch_size.^2);
dist_ro_ori = (min(dist_all_ro_ori')).*ro_pwei;
dist_ori_ro = (min(dist_all_ro_ori)).*ori_pwei;
% d_ro_ori = sum(dist_ro_ori)/(ro_row_num*ro_col_num);
% d_ori_ro = sum(dist_ori_ro)/(ori_row_num*ori_col_num);
% d_ro_ori = sum(dist_ro_ori);
% d_ori_ro = sum(dist_ori_ro);
d_ro_ori = sum(dist_ro_ori)/((ro_row_num*ro_col_num)*max(dist_ro_ori));
d_ori_ro = sum(dist_ori_ro)/((ori_row_num*ori_col_num)*max(dist_ori_ro));

Loc_dis = d_ro_ori + d_ori_ro;





