function dist_salient_aes (Data,k1,k2)
% function [HSV_dist] = HSV_dist(IMP,RONum)
%clear all
%close all
RO =[1,2,3,4,5,6,7,8];
RONum =1;
%ROName = {'cr','sv','multiop','sc','scl','sm','sns','warp'};
%load ('data.mat');

for j = k1 : k2
%folder = regexp(char(data.name(j)),'[a-zA-Z]+(_[a-zA-Z]+)+[a-zA-Z0-9]*|[a-zA-Z]+[0-9]*|','match');
folder = regexp(char(Data.datasetNames(j)),'[a-zA-Z]+(_[a-zA-Z]+)+[a-zA-Z0-9]*|[a-zA-Z]+[0-9]*|','match');
IMP = load([pwd,filesep,'IP',filesep,char(folder),'_f','.mat']);

H_dist = zeros(1,RONum);
Area_dist = zeros(1,RONum);
% Area_dist2 = zeros(1,RONum);
Layout_dist = zeros(1,RONum);

%% compute the distance about the HSV difference of the important areas
% h_dist(1,i) record the distance about HSV of the i'th retargeted result

HSV_ori = IMP.ori_HSV/sum(IMP.ori_HSV);
for i = 1 : RONum
    x = IMP.ro_HSV(i,:);
    y = x/sum(x);   
    H_dist(1,i) = 0.5* sum(abs(HSV_ori - y));

end

%% compute the distance about the area distance of the important areas
% Area_dist(1,i) record the distance about the area difference of the i'th retargeted result
for i = 1 : RONum
    area_diff = abs(IMP.ro_Area(i,1) - IMP.ori_Area);
    max_ori_ro_area = max(IMP.ro_Area(i,1),IMP.ori_Area);
    min_ori_ro_area = min(IMP.ro_Area(i,1),IMP.ori_Area);
    Area_dist(1,i) =  area_diff / max_ori_ro_area;
    %Area_dist(1,i) =  area_diff /   IMP.ori_Area;
   % Area_dist2(1,i) = area_diff /  min_ori_ro_area;
end


%% compute the distance about the layout of important areas
% Layout_dist(1,i) record the distance about the layout of the i'th retargeted result
for i = 1 : RONum
    lay_dist = IMP.ro_Dist(i,:);
    Layout_dist(1,i) = min(lay_dist)/max(lay_dist);
    
end
  save([pwd,filesep,'salient_dist',filesep,char(folder),'-imp','.mat'],'H_dist','Area_dist','Layout_dist');  
end
disp('The computations of color, area, layout have finished. ');
end
%  x = load([pwd,filesep,'Imp_distance',filesep,char(folder),'-imp','.mat']);
