
%%
function fun_all_dist(Data,ROName,ori_type, sal_type,dir_ORI,dir_SAL,dir_Areas,k, patch_size)


%%
RONum = size(ROName,1);
k1 =1;
k2 = 1;
salient_content(Data,ori_type, sal_type, dir_ORI, dir_SAL, dir_Areas, ROName, k1, k2);
dist_salient_aes(Data,k1,k2);
dist_art(Data, ori_type, sal_type, dir_ORI, dir_SAL, patch_size, ROName, k1, k2);
dist_str_ssim_hdp(Data, ori_type, sal_type, dir_ORI,dir_Areas, patch_size, ROName, k1, k2)


%%
% "L2,SSIM,QMOS, HSV,Area,Layout,Local" record the distances for the i'th original image
% each of them contains the distances of 8 retargeted results

for i = 1 : k
 % obtain the original image

 folder = regexp(char(Data.datasetNames(i)),'[a-zA-Z]+(_[a-zA-Z]+)+[a-zA-Z0-9]*|[a-zA-Z]+[0-9]*|','match');
 ori_FilePath = [dir_ORI,filesep,char(folder),filesep,char(folder),ori_type];
 ori_image = imread(ori_FilePath);

 dis_IMP = load([pwd,filesep,'salient_dist',filesep,char(folder),'-imp','.mat']);
 dis_SSIM_QMOS = load([pwd,filesep,'new_ssim_qmos',filesep,char(folder),'_ssim_qmos','.mat']);
 dis_LOCAL_weight = load([pwd,filesep,'art_weights',filesep,char(folder),'-loc-wei','.mat']);
 
 dis_All.HSV = dis_IMP.H_dist;
 dis_All.Layout = dis_IMP.Layout_dist;
 dis_All.Area = dis_IMP.Area_dist;
 %dis_All.Local = dis_LOCAL.Local_dist;
 dis_All.Local_wei = dis_LOCAL_weight;
% L2 = zeros(1,RONum);
 SSIM = zeros(1,RONum);
 QMOS = zeros(1,RONum);
 
 for j = 1 : RONum
   %  L2(1,j) = dis_SSIM_QMOS.D(j,1).L2;
     SSIM(1,j) = dis_SSIM_QMOS.D(j,1).SSIM;
     QMOS(1,j) = dis_SSIM_QMOS.D(j,1).QMOS;
 end
 
% dis_All.L2 = L2; % record the L2 distance of the i'th  original image
 dis_All.SSIM = SSIM; % record the SSIM distance of i'th  original image
 dis_All.QMOS = QMOS; % record the QMOS distance of i'th  original image
 HSV = dis_All.HSV;   %  record the HSV distance of i'th  original image
 Layout = dis_All.Layout; % record the Layout distance of i'th  original image
 Area = dis_All.Area; % record the areas' change of i'th  original image
% Local = dis_All.Local; % record the Local distance computed by the bidirectional distances of i'th  original image
 LOCAL_weight = dis_All.Local_wei.Local_dist;
  %save([pwd,filesep,'All_distance_pz40',filesep,char(data.name(i)),'-all-dist','.mat'],'SSIM','QMOS','HSV','Layout','Area','Local','LOCAL_weight');
  save([pwd,filesep,'All_distance',filesep,char(folder),'-all-dist','.mat'],'SSIM','QMOS','HSV','Layout','Area','LOCAL_weight');  
end
disp('All computations have been finished.');

end

