function [histHSV,BWpix] = hsvhist(image,BW,normalize)
%UNTITLED1 Summary of this function goes here
%   Detailed explanation goes here

  % set up bin edges for histogram
  
  edges = zeros(256,1);
  for i = 1 : 256;
    edges(i) = i-1;
  end    

[h,s,v] = rgb2hsv(image);
h = h(BW);
s = s(BW);
v = v(BW);
BWpix=sum(sum(BW)); 

H = h; S = s; V = v;
h = h*360;

% Quantification of HSV space
%  h:16 level
%  s: 4 level
%  v: 4 level

H( h<=15  | h >345  )=0;
H( h >15  & h <=25  )=1;
H( h >25  & h <=45  )=2;
H( h >45  & h <=55  )=3;
H( h >55  & h <=80  )=4;
H( h >80  & h <=108 )=5;
H( h >108 & h <=140 )=6;
H( h >140 & h <=165 )=7;
H( h >165 & h <=190 )=8;
H( h >190 & h <=220 )=9;
H( h >220 & h <=255 )=10;
H( h >255 & h <=275 )=11;
H( h >275 & h <=290 )=12;
H( h >290 & h <=316 )=13;
H( h >316 & h <=330 )=14;
H( h >330 & h <=345 )=15;

S( s >0    & s <=0.15 )=0;
S( s >0.15 & s <=0.4  )=1;
S( s >0.4  & s <=0.75 )=2;
S( s >0.75 & s <=1    )=3;
 
V( v >0    & v <=0.15 )=0;
V( v >0.15 & v <=0.4  )=1;
V( v >0.4  & v <=0.75 )=2;
V( v >0.75 & v <=1    )=3;

% Combine 3 channel together L = H*Qs*Qv+S*Qv+ VQs,Qv is the quantification level of Saturation and Value ,
% L will in the range of [0,255]
% Qs = 4; Qv = 4

L = H*16 + S*4 + V;

% Compute histogram of L

histHSV = histc(L,edges)';

% normalise histogram bins -yes/no
  if normalize > 0
      histHSV = histHSV / BWpix;
  end