 
%**********************************************************************************************
% Copyright (C) Yun Liang, Yong-jin Liu and Diego Gutierrez.
% All rights reserved.
% if you use this code please refer to the paper, please cite "A similarity
% and aesthetic driven assessment for image retargeting", IEEE transaction
% on visualization and computer graphics, 2015.
%**********************************************************************************************
%%  How to use this code
% this is the version 1, we will optimize the code later
% (1) turn in to the "..\sym_com\toolbox" and run "vl_setup.m" , then you can use the symmetrr presercation quality computation
% (2) prepare the input images 
% (3) seletect if the image need to compute symmetry computation, if you need please set sym_flag =1 
% (4) run this code and get the quality on the command window
% some more information to use this code and its example, please refer to"read me"
  
%% settting the basic parameters

clear all
close all
clc
addpath(genpath(pwd));
ROName = {'ours'};  % please choose the retargeted result, for example if computed the quality of ours retargeted result, set ROName = {'ours'}; and tail_name = '_ours.bmp'; 
tail_name = '_ours.bmp'; 
ori_type = '.bmp'; 
sal_type = '.png';
dir_ORI = [pwd,filesep,'dataset-ORI'];
dir_SAL = [pwd,filesep,'dataset-SAL'];
dir_Areas = [pwd,filesep,'dataset-IMP-Areas'];

sym_flag = 0;
if sym_flag == 1
    load('data1.mat'); 
else
    load('data.mat');
end;

%% the best parameters for each component, namely the coefficients of the Q  in Eq.13 
% Q=0.45*Qsal+0.38Qart+0.1Qstr+0.07Qaes;
% these coefficients are computed by the section 4.1 

alpha_area = 0.6;
alpha_color = 0.4;
alpha_ssim = 0.9;
alpha_vdp = 0.1;
alpha_art = 0.38;
alpha_sal = 0.45;
alpha_str = 0.10;
alpha_aes = 0.07;

%% prepare for the quality computing

Data.datasetNames = data;
[k,c]=size(data);
patch_size = 20; 
RONum = size(ROName,1);
fileNum = size(Data.datasetNames,1);
Data.datasetNames = data;

%% 

if sym_flag == 1
  fun_sym_dist(Data,tail_name);
end;
 fun_all_dist(Data, ROName,ori_type, sal_type,dir_ORI,dir_SAL,dir_Areas, k, patch_size);
% 
% %

for i = 1 : k
 % obtain the original image
  folder = regexp(char(data(i)),'[a-zA-Z]+(_[a-zA-Z]+)+[a-zA-Z0-9]*|[a-zA-Z]+[0-9]*|','match');
 ori_FilePath = [dir_ORI,filesep,char(folder),filesep,char(folder),ori_type];
 ori_image = imread(ori_FilePath);
 
 %load the distances without the symmetry preservation quality
 dist_all =  load([pwd,filesep,'All_distance',filesep,char(folder),'-all-dist','.mat']);
 temp_imp = alpha_sal * (alpha_area * dist_all.Area(:) + alpha_color * dist_all.HSV(:))./2 ;
 temp_local = alpha_art * dist_all.LOCAL_weight(:) ;
 temp_str = alpha_str * (alpha_ssim * (1-dist_all.SSIM(:)) + alpha_vdp * (1-dist_all.QMOS(:)))./2 ;
 temp_layout = alpha_aes * dist_all.Layout(:);
 d(i) = temp_imp + temp_local + temp_layout + temp_str; 
end

%
if sym_flag == 1
    Q_sym_all = load([pwd,filesep,'sym_dist',filesep,char(folder),'.mat']);
    Q_sym = Q_sym_all.all_sym(4,1);
    alpha_sym = 0.87;
    d = (1-alpha_sym)*d + alpha_sym * Q_sym;
end

disp(['The image quality by our measure is ', num2str(d)]);

%%




