
clear all
close all
clc

%%
addpath(genpath(pwd));
load('data.mat');
Data.datasetNames = data;
ROName = {'sv'};
sym_flag = 0;
%tail_name = '_ours.bmp';

%% 

RONum = size(ROName,1);
ori_type = '.bmp';
sal_type = '.png';
fileNum = size(Data.datasetNames,1);
dir_ORI = [pwd,filesep,'dataset-ORI'];
dir_SAL = [pwd,filesep,'dataset-SAL'];
dir_Areas = [pwd,filesep,'dataset-IMP-Areas'];
k = 1;
patch_size = 20;

% 
%%
% alpha_area = 0.79;
%  alpha_hsv = 0.21;
% alpha_ssim = 0.55;
% alpha_qmos = 0.45;
% 
% alpha_local = 0.18;
% alpha_imp = 0.45;
% alpha_str = 0.07;
% alpha_aes = 0.17;

% alpha_area = 0.85;
% alpha_hsv = 0.15;
% alpha_ssim = 0.55;
% alpha_qmos = 0.45;
% 
% alpha_local = 0.07;
% alpha_imp = 0.63;
% alpha_str = 0.11;
% alpha_aes = 0.22;


alpha_area = 0.6;
alpha_hsv = 0.4;
alpha_ssim = 0.9;
alpha_qmos = 0.1;

alpha_local = 0.38;
alpha_imp = 0.45;
alpha_str = 0.10;
alpha_aes = 0.07;


%% 
% fun_all_dist is defined to compute all the distance components of our measure without the symmetry distance

%tail_name(k).tail = ROName;


if sym_flag == 1
fun_sym_dist(Data,tail_name);
end;
fun_all_dist(Data, ROName,ori_type, sal_type,dir_ORI,dir_SAL,dir_Areas, k, patch_size);

for i = 1 : k
 % obtain the original image
 folder = regexp(char(data(i)),'[a-zA-Z]+(_[a-zA-Z]+)+[a-zA-Z0-9]*|[a-zA-Z]+[0-9]*|','match');
 ori_FilePath = [dir_ORI,filesep,char(folder),filesep,char(folder),ori_type];
 ori_image = imread(ori_FilePath);
 dist_all =  load([pwd,filesep,'All_distance',filesep,char(folder),'-all-dist','.mat']);
 temp_imp = alpha_imp * (alpha_area * dist_all.Area(:) + alpha_hsv * dist_all.HSV(:))./2 ;
 temp_local = alpha_local * dist_all.LOCAL_weight(:) ;
 temp_str = alpha_str * (alpha_ssim * (1-dist_all.SSIM(:)) + alpha_qmos * (1-dist_all.QMOS(:)))./2 ;
 temp_layout = alpha_aes * dist_all.Layout(:);
 d(i) = temp_imp + temp_local + temp_layout + temp_str;
 
end

disp(['The distance by our measure is ', num2str(d)]);

%%




