% VL_DEMO_MSER_BASIC  Demo: MSER: basic functionality
clear all
close all
clc
tic
pfx = fullfile(vl_root,'figures','demo') ;
randn('state',0) ;
rand('state',0) ;
figure(1) ; clf ;
limit_w = 5;
limit_h = 5;
% --------------------------------------------------------------------
%                                                        Load a figure
% --------------------------------------------------------------------
%I = imread(fullfile(vl_root,'data','spots.jpg')) ;
I = imread(fullfile(vl_root,'data','birds_r1.bmp')) ;
I_ori = I;
image(I) ; colormap gray ;
axis equal ; axis off ; axis tight ;
vl_demo_print('mser_basic_0') ;

% --------------------------------------------------------------------
%                                       Convert the to required format
% --------------------------------------------------------------------


clf ; imagesc(I) ; %colormap(gray(256)) ;
axis equal ; axis off ; axis tight ;
I = uint8(rgb2gray(I)) ;
% --------------------------------------------------------------------
%                                                             Run VL_MSER
% --------------------------------------------------------------------
[r,f] = vl_mser(I,'MinDiversity',0.7,'MaxVariation',0.3,'Delta',23) ;
% for the birds_r1,birds_r2....birds_r6 0.7 changed to be 0.9, 23 changed
% to be 26
% compute regions mask
M = zeros(size(I)) ;
for x=r'
  s = vl_erfill(I,x) ;
  M(s) = M(s) + 1;
end
[dim,num] = size(f);
[height,width,dim] = size(I_ori);
limit_height = height ./3;
limit_width = width ./3;

% adjust convention
f = vl_ertr(f) ;
 k = 1;
for i = 20 : num
% figure ;
%  imshow(I_ori);
% hold on ;
t = f(:,i);
flag = 1;
% plotframe draw the feature frame(:mserеԲ)
[h1,allx,ally] = vl_plotframe(t) ; set(h1,'color','y','linewidth',3) ;
%h2 = vl_plotframe(t) ; set(h2,'color','k','linewidth',1) ;
%vl_demo_print('mser_basic_frames') ;

low_x = fix(min(allx) );
high_x = fix(max(allx));
low_y = fix(min(ally));
high_y = fix(max(ally));
h = high_y - low_y;
w = high_x - low_x;
initstate = [low_x,low_y,w,h];
patch = I_ori(low_y:high_y,low_x:high_x,:);
sym_region(i).patch = patch;
sym_region(i).low_x = low_x;
sym_region(i).low_y = low_y;

if ((h > limit_height) ||(w > limit_width) || (h < limit_h) ||(w < limit_w) )
    flag = 0;    
end
if  ( flag == 1 )
    filter_sym_region(k).patch = patch;
    filter_sym_region(k).low_x = low_x;
    filter_sym_region(k).low_y = low_y;
    filter_sym_region(k).h = h;
    filter_sym_region(k).w = w;
    filter_sym_region(k).idx = i;
     k = k + 1;   
    
end


% figure;
% imshow(patch);
% figure;
% imshow(I_ori);
% hold on;
%  rectangle('Position',initstate,'LineWidth',4,'EdgeColor','r');
end
toc

%%  





%%
