% VL_DEMO_MSER_BASIC  Demo: MSER: basic functionality
clear all
close all
pfx = fullfile(vl_root,'figures','demo') ;
randn('state',0) ;
rand('state',0) ;
figure(1) ; clf ;

% --------------------------------------------------------------------
%                                                        Load a figure
% --------------------------------------------------------------------
%I = imread(fullfile(vl_root,'data','spots.jpg')) ;
I = imread(fullfile(vl_root,'data','chuang_sy.bmp')) ;
I_ori = I;
image(I) ; colormap gray ;
axis equal ; axis off ; axis tight ;
vl_demo_print('mser_basic_0') ;

% --------------------------------------------------------------------
%                                       Convert the to required format
% --------------------------------------------------------------------


clf ; imagesc(I) ; %colormap(gray(256)) ;
axis equal ; axis off ; axis tight ;
I = uint8(rgb2gray(I)) ;
% --------------------------------------------------------------------
%                                                             Run VL_MSER
% --------------------------------------------------------------------
[r,f] = vl_mser(I,'MinDiversity',0.7,'MaxVariation',0.3,'Delta',10) ;
% for the birds_r1,birds_r2....birds_r6 0.7 changed to be 0.9, 23 changed
% to be 26
% compute regions mask
M = zeros(size(I)) ;
for x=r'
  s = vl_erfill(I,x) ;
  M(s) = M(s) + 1;
end

% adjust convention
f = vl_ertr(f) ;

figure ;
imshow(I_ori);
hold on ;
% plotframe draw the feature frame(:mserеԲ)
h1 = vl_plotframe(f) ; set(h1,'color','r','linewidth',3) ;
%h2 = vl_plotframe(f) ; set(h2,'color','k','linewidth',1) ;
vl_demo_print('mser_basic_frames') ;

ff = f;

[rows,cols] = size(f);
for i = 1 : cols
    if(ff(3,i)<30 || ff(5,i) <5) 
        ff(1,i) =0;
        ff(2,i) = 0;
        ff(3,i)=0;
        ff(4,i) = 0;
        ff(5,i) = 0;
    else if(ff(3,i)>2000) 
                  ff(1,i) =0;
        ff(2,i) = 0;
            ff(3,i)=0;
            ff(4,i)=0;
            ff(5,i) = 0;
        end
    end
    %% chuang_ori ff(1,i) >800   d1 = abs(ff(1,i) - 640);    d2 = abs(ff(2,i) - 410); d1<40, d2<40, 
    % chuang_Mop  ff(1,i)>500   d1 = abs(ff(1,i) - 420);    d2 = abs(ff(2,i) - 420); d1<30, d2<30
    % chuang_sy   d1 = abs(ff(1,i) - 413);    d2 = abs(ff(2,i) - 424); d1<5, d2<5
    if ff(1,i) > 500
     ff(1,i) =0;
        ff(2,i) = 0;
        ff(3,i) = 0;
        ff(4,i) = 0;
        ff(5,i) = 0;   
    end
    d1 = abs(ff(1,i) - 413);
    d2 = abs(ff(2,i) - 424);
    if (d1 <20) && (d2 < 20) 
        ff(1,i) =0;
        ff(2,i) = 0;
        ff(3,i) = 0;
        ff(4,i) = 0;
        ff(5,i) = 0;
    end
end
%% for chuang_ori
% ff(3,40) = f(3,40);
% ff(4,40) = f(4,40);
% ff(5,40) = f(5,40);
% ff(3,40) = f(3,40);
% for chuang_mop
% ff(3,111) = 0;
% ff(4,111) = 0;
% ff(5,111) = 0;


%%
figure;
imshow(I_ori);
hold on ;
% plotframe draw the feature frame(:mserеԲ)
h1 = vl_plotframe(ff) ; set(h1,'color','r','linewidth',2) ;
%h2 = vl_plotframe(ff) ; set(h2,'color','k','linewidth',1) ;
vl_demo_print('mser_basic_frames') 



% figure(2) ; clf ; imagesc(I) ; hold on ;
% colormap(gray(256)) ;
% [c,h]=contour(M,(0:max(M(:)))+.5) ;
% set(h,'color','y','linewidth',3) ;
% axis equal ; axis off ;
% vl_demo_print('mser_basic_contours') ;

% --------------------------------------------------------------------
%                                                       Run VL_MSER again
% --------------------------------------------------------------------

% [r,f] = vl_mser(I,'MinDiversity',0.7,'MaxVariation',0.2,...
%   'Delta',10,'BrightOnDark',1,'DarkOnBright',0) ;
% 
% % adjust convention
% f = vl_ertr(f) ;
% 
% % compute regions mask
% M = zeros(size(I)) ;
% for x=r'
%   s = vl_erfill(I,x) ;
%   M(s) = M(s) + 1;
% end
% 
% figure(3) ;
% hold on ;
% h1 = vl_plotframe(f) ; set(h1,'color','g','linewidth',2) ;
% %h2 = vl_plotframe(f) ; set(h2,'color','k','linewidth',1) ;
% vl_demo_print('mser_basic_frames_both') ;
% 
% figure(4) ;
% [c,h]=contour(M,(0:max(M(:)))+.5) ;
% set(h,'color','g','linewidth',3) ;
% 
% hold on ; axis equal ; axis off ;
% vl_demo_print('mser_basic_contours_both') ;
